﻿Rem
WallRun! - Count-Doku
Für den BCC#48
EndRem
SuperStrict
AppTitle = "WallRun!"
SetGraphicsDriver GLMax2DDriver()
Graphics 400, 500, 0, 60, GRAPHICS_BACKBUFFER

SetMaskColor 255, 0, 255
Global WallList:TList = CreateList()
Global wallImg:TImage = LoadImage("data\wall.png")
Global BlockList:TList = CreateList()
Global blockImg:TImage = LoadImage("data\block.png")
MidHandleImage blockImg
Global lastBlock:Int = MilliSecs()
Global playerImg:TImage = LoadAnimImage("data\player.png", 32, 32, 0, 24)
MidHandleImage playerImg
Global shieldImg:TImage = LoadImage("data\shield.png")
Global ShieldList:TList = CreateList()
Global lastShield:Int = MilliSecs()
Global clothesImg:TImage = LoadImage("data\clothes.png")
Global clothesList:TList = CreateList()
Global lastCloth:Int = MilliSecs()
Global monsterImg:TImage = LoadAnimImage("data\monster.png", 32, 32, 0, 6)
Global monsterList:TList = CreateList()
Global lastMonster:Int[2]
Global helpIMG:TImage = LoadImage("data\help.png")
Global spriteIMG:TImage = LoadAnimImage("data\sprites.png", 64, 32, 0, 2)
MidHandleImage spriteIMG
Global spriteList:TList = CreateList()
Global lastWolke:Int = MilliSecs()
Global ScoreIMG:TImage = LoadImage("data\highscore.png")
Global ScoreList:TList = CreateList()
Global hScore:TStream = ReadFile("data\hscore.dat")
Global HighScore:Int = ReadInt(hscore)
CloseFile hScore
Global particleIMG:TImage = LoadImage("data\particle.png")

Global mapSpeed:Float = 0.1 ' <---  Scrollgeschwindigkeit
SeedRnd MilliSecs()

Type TWall
	Field x:Int, y:Float
	Function Create:TWall(nx:Int, ny:Int)
		Local nwa:TWall = New TWall
		WallList.AddLast(nwa)
		nwa.x = nx
		nwa.y = ny
		Return nwa:TWall
	End Function
	Function Update:TWall(newItemsAll:Byte = 1)
	For Local wll:TWall = EachIn WallList
			If wll.x > 200 Then SetScale - 1, 1
			DrawImage wallImg, wll.x, wll.y * 32
			SetScale 1, 1
			If wll.y * 32 > 500
				TWall.Create(wll.x, -1)
				WallList.Remove(wll)
				If newItemsAll = 1
					Local newItem:Int = Rand(0, 10)
					If newItem = 0 And lastBlock + 500 < MilliSecs() And score > 2000
						If Rand(0, 1) = 0
							TBlock.Create(16, -1)
						Else
							TBlock.Create(400 - 16, 0)
						End If
						lastBlock = MilliSecs()
					ElseIf newItem = 1 And lastShield + 10000 < MilliSecs()
						If Rand(0, 1) = 0
							TShield.Create(16, 0)
						Else
							TShield.Create(400 - 32, 0)
						End If
						lastShield = MilliSecs()
					ElseIf newItem = 2 And lastCloth + 2000 < MilliSecs()
						TClothes.Create(-1)
						lastCloth = MilliSecs()
					ElseIf newItem = 3 And lastMonster[0] + 2000 < MilliSecs() And score > 1000
						TMonster.Create(Rnd(0, 400), 0, 1)
						lastMonster[0] = MilliSecs()
					ElseIf newItem = 4 And lastMonster[1] + 5000 < MilliSecs() And score > 3000
						TMonster.Create(Rand(0, 1), 0, 2)
						lastMonster[1] = MilliSecs()
					End If
				End If
			End If
			wll.y = wll.y + mapSpeed
		Next
	End Function
End Type
Type TBlock
	Field x:Int, y:Float
	Function Create:TBlock(nx:Int, ny:Int)
		Local bck:TBlock = New TBlock
		BlockList.AddLast(bck)
		bck.x = nx
		bck.y = ny
		Return bck
	End Function
	Function Update:TBlock()
		For Local bck:TBlock = EachIn BlockList
			If ImagesCollide(playerImg, Player.x, Player.y, Player.frame, blockImg, bck.x, bck.y * 32, 0)
				If Player.active[0] = True
					Player.active[0] = False
					BlockList.Remove(bck)
				Else
					TSprite.Create(Player.x, Player.y, 1)
					gamestat = 0
					FlushKeys
				EndIf
			End If
			DrawImage blockImg, bck.x, bck.y * 32
			SetScale 1, 1
			If bck.y > 500
				BlockList.Remove(bck)
			End If
			bck.y = bck.y + mapSpeed
		Next
		End Function
End Type
Type TClothes
	Field y:Float
	Function Create:TClothes(y:Int)
		Local clt:TClothes = New TClothes
		clothesList.AddLast(clt)
		clt.y = y
		If Rand(0, 1) = 0 Then TMonster.Create(Rnd(0, 400), y, 0)
		Return clt
	End Function
	Function Update:TClothes()
		For Local clt:TClothes = EachIn clothesList
			DrawImage clothesImg, 0, clt.y * 32
			If clt.y > 500
				clothesList.Remove(clt)
			End If
			clt.y:+mapSpeed
		Next
	End Function
End Type
Type TMonster
	Field x:Float, y:Float, art:Int, direction:Int, olddirection:Int, speed:Float, frame:Float
	Function Create:TMonster(x:Float, y:Float, art:Int)
		Local msr:TMonster = New TMonster
		monsterList.AddLast(msr)
		If art < 2
			msr.x = x
			If x < 200 Then msr.direction = 0
			If x > 200 Then msr.direction = 1
			msr.speed = Rnd(3, 7)
		ElseIf art = 2
			msr.direction = x
			If x = 0 Then x = 16
			If x = 1 Then x = 400 - 16
			msr.x = x
			msr.speed = Rnd(0.0, 0.2)
		End If
		msr.y = y - 0.8
		msr.art = art
			
		Return msr
	End Function
	Function Update:TMonster()
		For Local msr:TMonster = EachIn monsterList
			If msr.direction = 1 Then SetScale - 1, 1
			DrawImage monsterImg, msr.x, msr.y * 32, 2 * msr.art + Int(msr.frame)
			If ImagesCollide(playerImg, Player.x, Player.y, Player.frame, monsterImg, msr.x, msr.y * 32, (2 * msr.art) + Int(msr.frame))
				If msr.art = 2
					If Player.active[0] = True
						Player.active[0] = False
						monsterList.Remove(msr)
					Else
						TSprite.Create(Player.x, Player.y, 1)
						gamestat = 0
						FlushKeys
					EndIf
				Else
					Local plTestVal:Int = Player.oldwall
					If Player.wall <> plTestVal Or (Player.wall = 0 And plTestVal = 0)
						monsterList.Remove(msr)
						If Player.sort <> msr.art Then Player.items = 0
						If Player.items < 3
							Player.items:+1
							Player.sort = msr.art
						End If
					Else
						If Player.active[0] = True
							Player.active[0] = False
							monsterList.Remove(msr)
							If Player.sort <> msr.art Then Player.items = 0
							If Player.items < 3
								Player.items:+1
								Player.sort = msr.art
							End If
						Else
							TSprite.Create(Player.x, Player.y, 1)
							gamestat = 0
							FlushKeys
						EndIf
					End If
				End If
			End If
							
			SetScale 1, 1
			If msr.art < 2
				If msr.direction = 1
					msr.x:+msr.speed
				ElseIf msr.direction = 0
					msr.x:-msr.speed
				End If
				If msr.x < 32 Then msr.direction = 1
				If msr.x > 400 - 32 Then msr.direction = 0
			End If
			If msr.y > 500
				monsterList.Remove(msr)
			End If
			If msr.art = 0
				msr.y:+mapSpeed
			ElseIf msr.art = 1
				msr.y:+mapSpeed + Rnd(0.02, 0.05)
			ElseIf msr.art = 2
				msr.y:+mapSpeed + msr.speed
			End If
			msr.frame:+0.05
			If msr.frame > 1.9 Then msr.frame = 0
		Next
	End Function
End Type
Type TShield
	Field x:Float, y:Float
	Function Create:TShield(nx:Int, ny:Int)
		Local shd:TShield = New TShield
		ShieldList.AddLast(shd)
		shd.y = ny
		shd.x = nx
		Return shd:TShield
	End Function
	Function Update:TShield()
		For Local shd:TShield = EachIn ShieldList
			If ImagesCollide(playerImg, Player.x, Player.y, Player.active[0], shieldImg, shd.x, shd.y * 32, 0)
				If Player.shields < 3
					Player.shields:+1
				Else
					Player.active[0] = True
				End If
				ShieldList.Remove(shd)
			End If
			DrawImage shieldImg, shd.x, shd.y * 32
			If shd.y > 500
				ShieldList.Remove(shd)
			End If
			shd.y:+mapSpeed
		Next
	End Function
End Type
Type TPlayer
	Field x:Float, y:Float
	Field wall:Int, oldwall:Float
	Field items:Int, sort:Int, timer:Int
	Field shields:Int, active:Int[3], frame:Int
	Field animFrame:Float
	Function Create:TPlayer(wall:Int, ny:Int)
		Local plr:TPlayer = New TPlayer
		plr.y = ny
		plr.wall = wall
		plr.oldwall = wall
		Return plr:TPlayer
	End Function
	Function Update:TPlayer(plr:TPlayer)
		plr.x = plr.oldwall * 175 + 200
		If plr.wall = 1 Then SetScale - 1, 1
		DrawImage playerImg, plr.x, plr.y, plr.frame
		If plr.active[1] = 0
			If plr.wall > plr.oldwall Then plr.oldwall:+0.1
			If plr.wall < plr.oldwall Then plr.oldwall:-0.1
		End If
		If plr.oldwall = -1.00000012 Then plr.oldwall = -1
		If plr.oldwall = 0.900000095 Then plr.oldwall = 1
		SetScale 1, 1
		plr.animFrame = plr.animFrame + 0.1
		If plr.animFrame > 3.9 Then plr.animFrame = 0
		plr.frame = Int(plr.animFrame) + 4 * plr.active[0] + 8 * plr.active[1] + 8 * plr.active[2]
		SetColor 125, 125, 125
		DrawRect 0, 480, 40, 20
		DrawOval 30 - 2.5, 480, 20, 20
		DrawOval 360 - 10, 480, 20, 20
		DrawRect 360, 480, 40, 20
		SetColor 255, 255, 255
		For Local i:Int = 0 To plr.shields - 1
			DrawImage shieldImg, 15 * i, 500 - 18
		Next
		SetScale 0.70, 0.70
		For Local i:Int = 0 To plr.items - 1
			DrawImage monsterImg, 15 * i + 355, 500 - 18, plr.sort * 2
		Next
		SetScale 1, 1
	End Function
End Type
Type TSprite
	Field x:Float, y:Float, art:Byte, xs:Float, ys:Float, scale:Float, rot:Float
	Function Create:TSprite(x:Float, y:Float, art:Byte)
		Local spr:TSprite = New TSprite
		spriteList.AddLast(spr)
		spr.art = art
		spr.x = x
		spr.y = y
		spr.xs = Rnd(-0.5, 0.5)
		spr.ys = 0
		spr.scale = Rnd(-3, 3)
		spr.rot = Rnd(-10, 10)
		Return spr:TSprite
	End Function
	Function Update:TSprite(artS:Byte)
		For Local spr:TSprite = EachIn spriteList
			If spr.art = artS
				If spr.art = 0
					SetScale spr.scale, spr.scale
					SetRotation spr.rot
					DrawImage spriteIMG, spr.x, spr.y, spr.art
					SetScale 1, 1
					SetRotation 0
					spr.x:+spr.xs
					spr.y:+spr.ys
					If spr.x < 0 Or spr.x > 400 Or spr.y < 0 Or spr.y > 500 Then spriteList.Remove(spr)
				ElseIf spr.art = 1
					SetRotation spr.rot
					DrawImage spriteIMG, spr.x, spr.y, spr.art
					SetRotation 0
					spr.y:+mapSpeed * 20
					If spr.y > 500 Then spriteList.Remove(spr)
				End If
			End If
		Next
	End Function
End Type
Type THScore
	Field y:Float, emit:TEmitter
	Global set:Byte
	Function Create:THScore(y:Float)
		Local scr:THScore = New THScore
		ScoreList.AddLast(scr)
		scr.y = y
		scr.emit = TEmitter.Create(200, y, 0, 360, 2, 5, 1, 100, 2, 10)
		Return scr:THScore
	End Function
	Function Update:THScore()
		If score > HighScore And THScore.set = 0
			THScore.set = 1
			THScore.Create(-100)
		End If
		For Local scr:THScore = EachIn ScoreList
			DrawImage ScoreIMG, 0, scr.y
			scr.y:+mapSpeed * 20
			scr.emit.y:+mapSpeed * 20
			If scr.y > 500
				ScoreList.Remove(scr)
				TEmitter.emitList.Remove(scr.emit)
			End If
		Next
	End Function
End Type
Type TEmitter'Type For Emitters
	Field x:Float, y:Float, min_winkel:Float, max_winkel:Float, time:Float, akt_time:Float
	'mit x,y Position ; Abstrahlwinkel ; Zeit bis zur nächsten Partikelemission ; aktuelle Zeit 
	Field parts_per_activation:Int, max_life:Int, min_life:Int, min_speed:Float, max_speed:Float
	'     Partikel pro Emmision ; Leben der Partikel ; Min_Geschw ; Max_Geschw
	Field activated:Int
	Global emitList:TList = CreateList()
	Function Create:TEmitter(x:Float, y:Float, min_winkel:Float, max_winkel:Float, time:Int, parts_activation:Int, min_life:Int, max_life:Int, min_speed:Float, max_speed:Float)
		Local e:TEmitter = New TEmitter
		TEmitter.emitList.AddLast(e)
		e.x = x
		e.y = y
		e.min_winkel = min_winkel
		e.max_winkel = max_winkel
		e.time = time
		e.parts_per_activation = parts_activation
		e.max_life = max_life
		e.min_life = min_life
		e.max_speed = max_speed
		e.min_speed = min_speed
		e.activated = True
		Return e
	End Function
	Function Update:TEmitter()
		For Local e:TEmitter = EachIn TEmitter.emitList'Go thrue all Emitters
			If e.activated = True
				If MilliSecs() > e.time + e.akt_time'time to send out a new particle?
					For Local k:Int = 1 To e.parts_per_activation'How many?
						TParticle.Create(e.x, e.y, Rnd(e.min_winkel:Float, e.max_winkel:Float), Rand(e.min_life, e.max_life), Rnd(e.min_speed, e.max_speed))
					Next
					e.akt_time = MilliSecs()
				End If
			End If
		Next
	End Function
End Type
Type TParticle'Type for Particles
	Field x:Float, y:Float, winkel:Float, life:Int, speed:Float
	'mit x,y Position ; Winkel ; Leben ; Farbe
	Global partList:TList = CreateList()
	Function Create:TParticle(x:Float, y:Float, winkel:Float, life:Int, speed:Float)
		Local p:TParticle = New TParticle
		TParticle.partList.AddLast(p)
		p.x = x
		p.y = y
		p.winkel = winkel
		p.life = life
		p.speed = speed
		Return p
	End Function
	Function Update:TParticle()
		For Local p:TParticle = EachIn TParticle.partList'Go thrue all Particles
			If p.life > 0 And (p.x > 1 And p.x < 398) And (p.y > 1 And p.y < 498)'On screen and at "live"?
				SetColor Rand(20, 255), Rand(20, 255), Rand(20, 255)
				DrawImage particleIMG, p.x, p.y'draw Particles
				p.x = p.x + Cos(p.winkel) * -p.speed'Calculate New position
				p.y = p.y + Sin(p.winkel) * p.speed
				p.life = p.life - 1
			Else'Delete if they are out of screen or "dead"
				TParticle.partList.Remove(p)
			End If
		Next
End Function
End Type

Global Player:TPlayer
Global score:Int, gamestat:Byte = 0
Init()
SetClsColor 107, 203, 255
While Not (AppTerminate())
	Cls
	If lastWolke + 2000 < MilliSecs() And Rand(0, 10) < 2
		TSprite.Create(Rand(50, 350), Rand(50, 450), 0)
		lastWolke = MilliSecs()
	End If
	TSprite.Update(0)
	TWall.Update(gamestat)
	TClothes.Update()
	TMonster.Update()
	TBlock.Update()
	TShield.Update()
	TSprite.Update(1)
	TParticle.Update()
	TEmitter.Update()
	If gamestat = 1
		THScore.Update()
		TPlayer.Update(Player:TPlayer)
		If KeyHit(KEY_LEFT) And Player.oldwall >= Player.wall Then Player.wall = -1
		If KeyHit(KEY_RIGHT) And Player.oldwall <= Player.wall Then Player.wall = 1
		
		If KeyHit(KEY_DOWN) And Player.shields > 0 And Player.active[0] = 0
			Player.active[0] = True
			Player.shields:-1
		End If
		If KeyHit(KEY_UP) And Player.items = 3
			Player.wall = 0
			Player.oldwall = 0
			Player.items = 0
			ChangeSpeed(0.2)
			Player.active[1] = True
			If Player.sort = 1 Then Player.active[2] = True
			If Player.sort = 1
				Player.timer = MilliSecs() + 5000
			ElseIf Player.sort = 0
				Player.timer = MilliSecs() + 2500
			End If
		End If
		If Player.timer < MilliSecs() And Player.oldwall = 0
			If Player.wall = 0 And Player.oldwall = 0
				Player.wall = Rand(-1, 1)
				Player.oldwall = Player.wall
			End If
			ChangeSpeed(0.1)
			Player.active[1] = False
			Player.active[2] = False
		End If
		SetColor 125, 125, 125
		DrawOval 160, 480, 20, 20
		DrawRect 170, 480, 60, 20
		DrawOval 220, 480, 20, 20
		SetColor 0, 0, 0
		DrawText score, 170, 483
		SetColor 255, 255, 255
		score:+mapSpeed * 10
		If KeyHit(KEY_ESCAPE) Then gamestat = 0
	ElseIf gamestat = 0
		Menu()
		If KeyHit(KEY_ESCAPE) Then End
	End If
	Flip
Wend
End
Function Menu()
	SetColor 0, 0, 0
	If score > 0
		DrawText "GameOver!", 164, 10
		DrawText "Deine Punkte: " + score, 200 - TextWidth("Deine Punkte: " + score) / 2, 25
		If score > HighScore
			SetColor 255, 0, 0
			DrawText "Super du hast einen neuen HighScore erreicht!", 20, 50
			SetColor 0, 0, 0
			hScore = WriteFile("data\hscore.dat")
			WriteInt hScore, score
			CloseFile hScore
		End If
	Else
		DrawText "Willkommen!", 156, 10
		DrawText "HighScore: " + HighScore, 200 - TextWidth("HighScore: " + HighScore) / 2, 25
	End If
	DrawText "(Neu-)Starten: PfeilOben", 32, 430
	DrawText "Hilfe: PfeilUnten", 32, 445
	DrawText "Highscore Reset: PfeilLinks",32,460
	DrawText "Beenden: Escape", 32, 475
	SetColor 255, 255, 255
	
	If KeyHit(KEY_UP)
		gamestat = 1
		If score > HighScore Then HighScore = score
		Init()
		FlushKeys
	ElseIf KeyDown(KEY_DOWN)
		DrawImage helpIMG, 0, 0
	ElseIf KeyHit(KEY_LEFT)
		score = 0
		HighScore = 0
		hScore = WriteFile("data\hscore.dat")
		WriteInt hScore, score
		CloseFile hScore
	End If
End Function
Function Init()
	BlockList.Clear()
	clothesList.Clear()
	monsterList.Clear()
	ShieldList.Clear()
	WallList.Clear()
	spriteList.Clear()
	ScoreList.Clear()
	THScore.set = 0
	Player = Null
	Player = TPlayer.Create(1, 350)
	ChangeSpeed(0.1)
	score = 0
End Function
Function ChangeSpeed(newSpeed:Float)
		WallList.Clear()
	mapSpeed = newSpeed
	For Local i:Int = -1 To 16
		TWall.Create(0, i)
		TWall.Create(400, i)
	Next
End Function
