SuperStrict

Framework BRL.GLMax2D
Import BRL.Timer
Import BRL.FreeTypeFont
Import BRL.PNGLoader
Import BRL.LinkedList
Import BRL.Random
Import BRL.Audio
Import BRL.FreeAudioAudio
Import BRL.OGGLoader
Import BRL.WAVLoader
?win32
Import "gfx/icon.o"
?

Const HMENU%=230
apptitle="BCC #48 - WASD"

Type Color
	Global hue%,mHue%,dHue%,timer%,aHue%
	Function SetHue(pHue%)
		aHue=mHue
		dHue=ATan2(Sin(pHue-mHue),Cos(pHue-mHue))
		timer=ticks+100
	End Function
	Function Update()
		If ticks<timer
			mHue=(aHue+dHue*(100-timer+ticks)/100.0+360)Mod 360
		Else
			mHue=aHue+dHue
		EndIf
		hue=mHue+Sin(ticks)*10
	End Function
	Function Set(pHueOffset%,pSat%=255,pBrs%=255)
		Local r%,g%,b%,h%=hue+pHueOffset
		r=_col(h,pSat,pBrs)
		g=_col(h-120,pSat,pBrs)
		b=_col(h-240,pSat,pBrs)
		SetColor r,g,b
		SetClsColor r,g,b
	End Function
	Function _col%(h%,s%,b%)
		Return ((Min(Max(0.5+Cos(h)/Cos(60)/2,0),1)-1)*b*s+b*255)/255.0
	End Function
End Type

Type Background
	Global imgPatterns:TImage
	Global mode%,newMode%,vis!
	Function Load()
		imgPatterns=LoadAnimImage("gfx/patterns.png",32,32,0,10)
		Set(0)
	End Function
	Function Set(pMode%)
		newMode=pMode
	End Function
	Function Draw()
		If mode<>newMode
			vis=Max(vis-dticks/25.0,0)
			If vis=0
				mode=newMode
			EndIf
		Else
			vis=Min(vis+dticks/25.0,1)
		EndIf
		Color.Set(0,128,8)
		Cls
		SetBlend ALPHABLEND
		SetAlpha 1
		For Local y%=0To 19
			For Local x%=0To 25
				Local phaseOff%=(x+y)Mod 4
				Local phase!=Sin(ticks+phaseOff*180)
				Color.Set(0,128,64+phase*24)
				SetRotation ticks/5.0+phaseOff*90
				SetScale (0.8+phase*0.2)*vis,(0.8+phase*0.2)*vis
				DrawImage imgPatterns,x*32,y*32-4,mode
			Next
		Next
	End Function
End Type

Type Interface
	Global imgInterface:TImage
	Function Load()
		imgInterface=LoadImage("gfx/interface.png")
	End Function
	Function Draw()
		SetScale 1,1
		SetBlend ALPHABLEND
		SetAlpha 1
		Color.Set(0)
		SetRotation 0
		DrawImage imgInterface,0,0
		If Game.state<>1 Return
		SetAlpha Game.stateVis
		Font.DrawText("Level",10,10,0.8)
		Font.DrawText(Level.lvl,10,40)
		Font.DrawText("Score",790,10,0.8,1)
		Font.DrawText(Game.scr,790,40,1,1)
	End Function
End Type

Type Menu
	Global imgBtn1:TImage
	Global imgBtn2:TImage
	Function Load()
		imgBtn1=LoadImage("gfx/button1.png")
		imgBtn2=LoadImage("gfx/button2.png")
	End Function
	Function Draw()
		If Game.state<>0
			Return
		EndIf
		SetScale 1,1
		SetBlend ALPHABLEND
		SetAlpha Game.stateVis
		If Key.hW And Game.stateVis=1
			Game.SetState(1)
			Game.timer=ticks+100
			Game.lvl=Null
			Game.scr=0
			Level.lvl=1
			Shield.invert=-1
			Player.health=12
			Background.Set(1)
		EndIf
		If Key.W
			Color.Set(180)
		Else
			Color.Set(0)
		EndIf
		DrawImage imgBtn1,144,10
		Font.DrawText("W",400,108,1,2,1)
		Font.DrawText("Start Game",400,140,1,2,1)

		Color.Set(0)
		DrawImage imgBtn2,110,170
		SetScale -1,1
		DrawImage imgBtn2,690,170

		If Key.hS
			Sound.active:~1
			Sound.chn.SetVolume(Sound.active)
		EndIf
		If Key.S
			Color.Set(180)
		Else
			Color.Set(0)
		EndIf
		SetScale 1,-1
		DrawImage imgBtn1,144,590
		Font.DrawText("S",400,492,1,2)
		Local txt$="Sound  On"
		If Sound.active=0
			txt$="Sound Off"
		EndIf
		Font.DrawText(txt$,400,460,1,2)
		If Key.esc And Game.stateVis=1
			End
		EndIf
	End Function
End Type

Type Game
	Global state%,newState%,stateVis!
	Global scr%,lvl:Level,timer%
	Function SetState(pState%)
		newState=pState
	End Function
	Function Update()
		If state<>newState
			stateVis=Max(stateVis-dticks/50.0,0)
			If stateVis=0
				state=newState
			EndIf
		Else
			stateVis=Min(stateVis+dticks/50.0,1)
		EndIf
		If state<>1 Or newState<>1 Return
		If lvl=Null And ticks=>timer
			lvl=New Level
		EndIf
		If Key.esc
			SetState(0)
			Background.Set(0)
			Shot.Clear()
			lvl=Null
			Color.SetHue(HMENU)
		EndIf
	End Function
End Type

Type Sound
	Global active%=True
	Global msc:TSound,chn:TChannel
	Global sfS:TSound,sfH:TSound,sfM:TSound
	Function Load()
		Local drvs$[] = ["FreeAudio DirectSound","FreeAudio Multimedia","FreeAudio","Null"]
		For Local drv$ = EachIn drvs
			If(AudioDriverExists(drv))
				SetAudioDriver(drv)
				Exit
			EndIf
		Next
		msc=LoadSound("snd/wasd.ogg",SOUND_LOOP)
		chn=PlaySound(msc)
		sfS=LoadSound("snd/shot.wav")
		sfH=LoadSound("snd/hit.wav")
		sfM=LoadSound("snd/miss.wav")
	End Function
End Type

Type Font
	Global img:TImage,offsetX%,offsetY%,width%,height%
	Function Load()
		img=LoadAnimImage("gfx/font.png",32,32,0,256)
		offsetX=1
		offsetY=6
		width=15
		height=19
	End Function
	Function DrawText(pText$,pX%,pY%,pScale!=1,pHAlign%=0,pVAlign%=0)
		pX:-offsetX*pScale
		If pHAlign=1
			pX:-pText.length*width*pScale
		ElseIf pHAlign=2
			pX:-pText.length*width*0.5*pScale
		EndIf
		py:-offsetY*pScale
		If pVAlign=1
			pY:-height*pScale
		ElseIf pVAlign=2
			pY:-height*0.5*pScale
		EndIf
		SetScale pScale,pScale
		For Local i%=0Until pText.length
			Local c%=pText[i]
			DrawImage img,pX+i*pScale*width,pY,c
		Next
	End Function
End Type

Type Key
	Global W%,A%,S%,D%
	Global hW%,hS%,esc%
	Function Update()
		W=KeyDown(KEY_W)
		A=KeyDown(KEY_A)
		S=KeyDown(KEY_S)
		D=KeyDown(KEY_D)
		hW=KeyHit(KEY_W)
		hS=KeyHit(KEY_S)
		esc=KeyHit(KEY_ESCAPE)
	End Function
End Type

Type Shield
	Global imgShield:TImage
	Global texts$[]=["W","WD","D","DS","S","SA","A","AW"]
	Global pos%
	Global invert%=-1
	Function Load()
		imgShield=LoadImage("gfx/shield.png")
	End Function
	Function Draw()
		If Game.state <> 1 Return
		SetAlpha Game.stateVis
		pos = GetPosition()
		For Local a%=0To 7
			SetRotation a*45
			SetScale 1,1
			Color.Set(0)
			SetBlend LIGHTBLEND
			If a=pos
				Color.Set(180)
			EndIf
			DrawImage(imgShield,400,300)
			SetRotation 0
			Font.DrawText(texts[a],400+Sin(a*45)*80,300-Cos(a*45)*80,1-(a Mod 2)*0.5,2,2)
		Next
	End Function
	Function GetPosition%()
		Local keys%=key.W*8+Key.D*4+Key.S*2+Key.A
		If keys=%1000~((invert=0)*8) Return 0
		If keys=%1100~((invert=1)*12) Return 1
		If keys=%0100~((invert=2)*4) Return 2
		If keys=%0110~((invert=3)*6) Return 3
		If keys=%0010~((invert=4)*2) Return 4
		If keys=%0011~((invert=5)*3) Return 5
		If keys=%0001~((invert=6)*1) Return 6
		If keys=%1001~((invert=7)*9) Return 7
		Return -1
	End Function
End Type

Type Level
	Global lvl%
	Field n%
	Field seq:Sequence,sCnt%
	Field miss%
	Field timer%
	Method New()
		n=lvl
		Game.lvl=Self
		timer=ticks+100
		Color.SetHue(Rand(360))
	End Method
	Method Update()
		If seq=Null And ticks=>timer And sCnt<5
			seq=New Sequence
			sCnt:+1
			If sCnt=5
				seq.last=True
			EndIf
		EndIf
	End Method
End Type

Type Sequence
	Global seqs%[][]=[[0,1,0,-1,0],[1,-1,1,-1,1,-1],[0,4,0,4,0,4],[0,0,-1,-1,1,1],[0,1,2,3,4,3,2,1],[0,1,2,3,4,5,6,7],[0,2,4,6,0],[0,4,2,6,0]]
	Field lvl:Level,nmb%,i%,dir%,start%
	Field miss%,l%,last%
	Field timer%
	Method New()
		nmb=Rand(0,seqs.length-1)
		l=seqs[nmb].length
		dir=1-Rand(0,1)*2
		start=Rand(0,8)
		lvl=Game.lvl
		timer=ticks
	End Method
	Method Update()
		If ticks=>timer
			timer:+30*Exp(-(Level.lvl-1)/15.0)
			Local pos%=(8+start+dir*seqs[nmb][i])Mod 8
			Local s:Shot=Shot.Create(pos,Self)
			i:+1
			If i=l
				s.last=True
				lvl.seq=Null
				lvl.timer=ticks+50
			EndIf
		EndIf
	End Method
End Type

Type Guns
	Global imgGun:TImage
	Global trigger%
	Function Load()
		imgGun=LoadImage("gfx/gun.png")
	End Function
	Function Draw()
		SetBlend ALPHABLEND
		If Game.state<>1 Return
		Color.Set(0,255,255)
		Local size!=0.5+Game.stateVis*0.5
		Local rad!=288+(1-Game.stateVis)*24
		SetScale size,size
		For Local a%=0To 315Step 45
			SetRotation a+90
			DrawImage imgGun,400+Cos(a)*rad,300+Sin(a)*rad
		Next
	End Function
End Type

Type Player
	Global imgPlayer:TImage
	Global imgHealth:TImage
	Global health%
	Function Load()
		imgPlayer=LoadImage("gfx/player.png")
		imgHealth=LoadImage("gfx/health.png")
	End Function
	Function Draw()
		Color.Set(180,255,255)
		SetBlend ALPHABLEND
		SetScale 1,1
		SetRotation 1
		DrawImage(imgPlayer,400,300)
		If Game.state<>1 Return
		SetBlend LIGHTBLEND
		For Local i%=0Until health*Game.stateVis
			SetRotation -i*30
			DrawImage imgHealth,400,300
		Next
	End Function
End Type

Type Shot
	Field x!,y!,vx!,vy!,pos%,seq:Sequence,last%	
	Global img:TImage
	Global list:TList=New TList
	Function Load()
		img=LoadImage("gfx/shot.png")
	End Function
	Function Create:Shot(pPos%,pSeq:Sequence)
		Local s:Shot=New Shot
		s.seq=pSeq
		s.pos=pPos
		Local p%=s.pos*45
		s.x=400+Sin(p)*290
		s.y=300-Cos(p)*290
		Local spd!=1.8*Exp((Level.lvl-1)/15.0)
		s.vx=-Sin(p)*spd
		s.vy=Cos(p)*spd
		list.AddLast(s)
		If Sound.active PlaySound(Sound.sfS)
		Return s
	End Function
	Function Update()
		For Local s:Shot=EachIn list
			s.x:+s.vx
			s.y:+s.vy
			Color.Set(180,255,255)
			SetBlend LIGHTBLEND
			SetScale 1,1
			SetRotation 0
			DrawImage img,s.x,s.y
			Local dx!=s.x-400
			Local dy!=s.y-300
			Local d!=dx*dx+dy*dy
			If d<12544
				If Shield.pos=s.pos
					Game.scr:+1
					s.Hit()
					If Sound.active PlaySound(Sound.sfH)
					Continue
				EndIf
			EndIf
			If d<2025
				s.Hit(False)
				If Sound.active PlaySound(Sound.sfM)
				Player.health:-1
				Shield.invert=Rand(0,7)
				Background.Set(2+Shield.invert)
				If Player.health=0
					Game.lvl=Null
					Game.SetState(2)
					Background.Set(0)
					Color.SetHue(0)
					Clear()
					Return
				EndIf
			EndIf
		Next
	End Function
	Method Hit(pHit%=True)
		Local sw:Shockwave=New Shockwave
		sw.x=x
		sw.y=y
		list.Remove(Self)
		If pHit=False
			seq.miss:+1
			seq.lvl.miss:+1
		EndIf
		If last=True
			If seq.miss=0
				Background.Set(1)
				Shield.invert=-1
			EndIf
			If seq.last=True
				If seq.lvl.miss=0
					Player.health=Min(Player.health+1,12)
				EndIf
				Level.lvl:+1
				Game.lvl=Null
				Game.timer=ticks+10
			EndIf
		EndIf
	End Method
	Function Clear()
		For Local s:Shot=EachIn list
			list.Remove(s)
		Next
	End Function
End Type

Type Shockwave
	Global l:TList=New TList,img:TImage
	Field x%,y%,t%
	Function Load()
		img=LoadImage("gfx/shockwave.png")
	End Function
	Method New()
		l.AddLast(Self)
	End Method
	Function Draw()
		For Local s:Shockwave=EachIn l
			SetBlend ALPHABLEND
			Color.Set(180)
			Local v!=s.t/100.0
			SetAlpha 1-v
			SetScale 0.2+v,0.2+v
			DrawImage img,s.x,s.y
			s.t:+4
			If s.t=100 l.Remove(s)
		Next
		SetAlpha 1
	End Function
End Type

Type GameOver
	Function Draw()
		If Game.State<>2 Return
		If Key.esc
			Game.SetState(0)
			Background.Set(0)
			Color.SetHue(HMENU)
		EndIf
		SetAlpha Game.stateVis
		Font.DrawText("Game Over",400,200,1,2,1)
		Font.DrawText("Level",200,260,1,0)
		Font.DrawText(Level.lvl,600,260,1,1)
		Font.DrawText("Score",200,340,1,0,1)
		Font.DrawText(Game.scr,600,340,1,1,1)
	End Function
End Type

SetGraphicsDriver GLMax2DDriver()
Graphics 800,600,0
Local timer:TTimer=CreateTimer(50)

Interface.Load()
Font.Load()
Menu.Load()
AutoMidHandle(1)
Background.Load()
Shield.Load()
Guns.Load()
Shot.Load()
Player.Load()
Shockwave.Load()
Color.aHue=HMENU
Sound.Load()

SeedRnd MilliSecs()

Global dticks%=1,ticks%


While Not AppTerminate()
	Color.Update()
	Key.Update()
	Game.Update()
	If Game.lvl<>Null
		Game.lvl.Update()
		If Game.lvl.seq<>Null
			Game.lvl.seq.Update()
		EndIf
	EndIf
	
	Background.Draw()
	Shockwave.Draw()
	Player.Draw()
	Shot.Update()
	Guns.Draw()
	Interface.Draw()
	Shield.Draw()
	Menu.Draw()
	GameOver.Draw()

	Flip 0
	dticks=WaitTimer(timer)
	ticks:+dticks
Wend
End