Rem
	Project:	Dark Cave for BCC#48
	Author:	skey-z
		
	Description:
		Du wachst in einem dunklen Verlies auf und muss den Weg nach drauen finden,
		um den nchsten Bereich zu erreichen bentigst du einen Schlssel, der sich irgendwo
		im Verlie versteckt.
		Damit es nicht ganz so einfach ist, hast du nur einen kleinen Sichtradius und alle besuchten Felder
		sind nur zur Hlfte sichtbar, Gegenstnde die noch dort liegen werden erst wieder sichtbar,
		wenn diese in den Sichtbereich kommen.
		
		Quelle: Grafiken und Sound von www.reinerstileset.4players.de
EndRem


SuperStrict

SeedRnd MilliSecs()

HideMouse



'STATES__________________________________________


	'Window_____________________
		
		Global gWidth:Int = 800
		Global gHeight:Int = 600
		
		Global midX:Int = (gWidth/2)
		Global midY:Int = (gHeight/2)
		
		Graphics gWidth, gHeight
	'___________________________
	
	'System_____________________
		
		'Gamestates
		Const cEND:Byte	= 0
		Const cMENU:Byte	= 1
		Const cGAME:Byte	= 2
		
		Global gState:Int = cMENU
		Global lState:Int = gState
		
		'Timer
		Local gameTimer:TTimer = CreateTimer(60)
		
		'Keys
		Local kh_esc:Byte
		Local kd_up:Byte
		Local kd_left:Byte
		Local kd_right:Byte
		Local kd_down:Byte
	'___________________________
	
	'Level______________________
		
		Local levelThis:Int = 1
		Local levelLast:Int
		
		Global mapDim:Int[]
		Global map:Int[,,,]
		
		Local mapSFX:TSound[4]
			mapSFX[0] = LoadSound("data/walk.wav")
			mapSFX[1] = LoadSound("data/key.wav")
			mapSFX[2] = LoadSound("data/diamond.wav")
			mapSFX[3] = LoadSound("data/door.wav")
		Local mapCHN:TChannel = AllocChannel()
			mapCHN.SetVolume(.25)
	'___________________________
	
	'Tileset____________________
		
		Local tileFile:String = "data/tileset.png"
		Global tileSize:Int = 64
		Local tileTiles:Int = getTiles(tileFile, tileSize)
		Local tileImg:TImage = LoadAnimImage(tileFile, tileSize, tileSize, 0, tileTiles, ALPHABLEND)
			MidHandleImage tileImg
		Global tileOffX:Int
		Global tileOffY:Int
		Local TX:Int
		Local TY:Int
		Local tileThis:Int
		
		Const tile_START:Int = 1
		Const tile_KEY:Int = 16
		Const tile_DIAMOND:Int = 17
		Const tile_DOORCLOSE:Int = 18
		Const tile_DOOROPEN:Int = 19
	'___________________________
	
	'Character__________________
	
		Local charFile:String = "data/mage.png"
		Local charSize:Int = 64
		Local charTiles:Int = getTiles(charFile, charSize)
		Local charImg:TImage = LoadAnimImage(charFile, charSize, charSize, 0, charTiles)
			MidHandleImage charImg
		
		Const cSTOP:Int=0
		Const cMOVE:Int=1
	
		Const cNORTH:Int=1
		Const cEAST:Int=2
		Const cSOUTH:Int=3
		Const cWEST:Int=4
		
		Local charDir:Int=3
		Local charFrame:Int
		Local charAnim:Int
		Local charMove:Int = False
		Local charFrames:Int=4
		Local charFrameStart:Int = MilliSecs()
		Local charFrameTime:Int=200
		
		Local charRad:Int = 1
		Local charRadValue:Int = 50
		Local charRadStart:Int = MilliSecs()
		Local charRadTime:Int = 250
		
		Local charKeys:Int
	'___________________________
	
	'Anzeige____________________
	
		Local radvalImg:TImage = LoadImage("data/radvalue.png")
		Local radImg:TImage = LoadImage("data/radius.png", MASKEDIMAGE)
			MidHandleImage radImg
	'___________________________
	
	'Menu_______________________
		
		Local menuMax:Int = 3
		Local menuSelect:Int = menuMax-1
		Local menuSelected:Int = -1
		Local menuSelectedLast:Int
		
		Local menuLevelMax:Int = countLevel("data/maps/")
		Local menuLevel:Int = levelThis
				
		Local menuString:String[menuMax]
			menuString[0] = "Spiel beenden"
			menuString[1] = "Level laden"
			menuString[2] = "Spiel starten"
			
		Local menuNavi:String[4]
			menuNavi[0] = "Beenden/Zurueck"
			menuNavi[1] = "Naechster"
			menuNavi[2] = "Bestaetigen"
			menuNavi[3] = "Letzer"
			
		Local menuNaviImg:TImage =LoadAnimImage("data/navi.png", 32, 32, 0, 4, MASKEDIMAGE)
		
		Local menuSFX:TSound[3]
			menuSFX[0] = LoadSound("data/back.wav")
			menuSFX[1] = LoadSound("data/klick.wav")
			menuSFX[2] = LoadSound("data/activate.wav")
			
	'___________________________
'________________________________________________

'MAINLOOP________________________________________

While Not(gState = cEND)
	
	WaitTimer gameTimer
	
	If AppTerminate() Then gState = cEND
	
	Select gState

		Case cMENU

			'Input____________________
				kd_up = KeyHit(KEY_UP)
				kd_left = KeyHit(KEY_LEFT)
				kd_right = KeyHit(KEY_RIGHT)
				kd_down = KeyHit(KEY_DOWN)
				FlushKeys()
			'_________________________
			
			'Proceed__________________
				
				lState = gState
				menuSelectedLast = menuSelected
				
				'Menu_Item
				If lState <> gState Then
					menuSelect = 2
					menuSelected = -1
					menuLevel = 1
				EndIf
				
				If kd_left Or kd_right Then
					PlaySound menuSFX[1]
				ElseIf kd_up Then
					PlaySound menuSFX[0]
				ElseIf kd_down Then
					PlaySound menuSFX[2]
				EndIf
				
				If kd_right  Then
					If (menuSelected < 0) Then
						menuSelect :- 1
						If (menuSelect<0) Then menuSelect = menuMax-1
					EndIf
				ElseIf kd_left Then
					If (menuSelected < 0) Then
						menuSelect :+ 1
						If (menuSelect>menuMax-1) Then menuSelect=0
					EndIf
				ElseIf kd_down Then
					menuSelected = menuSelect
				ElseIf kd_up Then
					If (menuSelected = -1) Then
						gState = cEND
					EndIf
				EndIf					
				
				
				Select menuSelected
					Case 2 'start
						gState = cGAME
						charRadValue = 50
					Case 1 'level
						If menuSelected = menuSelectedLast Then
							If kd_left Then
								menuLevel :- 1
								If (menuLevel<1) Then menuLevel =menuLevelMax
							ElseIf kd_right Then
								menuLevel :+ 1
								If (menuLevel>menuLevelMax) Then menuLevel = 1
							ElseIf kd_up Then
								menuSelected = -1
							ElseIf kd_down
								levelThis = menuLevel
								gState = cGAME
								charRadValue = 50
							EndIf
						EndIf
					Case 0 'quit
						gState = cEND
				End Select
			'_________________________
			
			'Output___________________
				
				SetBlend(ALPHABLEND)
				SetColor(255, 255, 255)
				SetRotation(0)
				SetScale(1, 1)
					
					For Local i:Int = 0 To 3
						DrawImage(menuNaviImg, midX+(Sin(i*90)*375)-16, midY-(Cos(i*90)*275)-16, i)
						DrawText(menuNavi[i], midX+(Sin(i*90)*325)-(TextWidth(menuNavi[i])/2), midY-(Cos(i*90)*250)-(TextHeight(menuNavi[i])/2))
					Next
					
				SetColor(255,0,0)
					DrawOval(midX-128, midY-128, 256, 256)
				SetColor(0,0,0)
					DrawOval(midX-127, midY-127, 254, 254)
					
				For Local i:Int = 0 To menuMax-1
					
					Local axis:Int = 360/menuMax
					Local px:Float = Sin(axis*i)*128
					Local py:Float = Cos(axis*i)*128
					
					If (i=menuSelect) Then
						SetColor(192, 0, 0)
						DrawRect(midX+px-64, midY+py-16, 128, 32)
						SetColor(0,0,0)
					Else
						SetColor(255,255,255)
					EndIf
					
					DrawText(menuString[i],midX+px-(TextWidth(menustring[i])/2), midY+py-(TextHeight(menuString[i])/2))
				Next
				
				If (menuSelected = 1) Then
					Local menuLevelOut:String = "Level: " + menuLevel
					DrawText(menuLevelOut, midX-(TextWidth(menuLevelOut)/2), midY-(TextHeight(menuLevelOut)/2))
				EndIf
			'_________________________
			
		Case cGAME
			
			'Input____________________
				kh_esc = KeyHit(KEY_ESCAPE)
				kd_up = KeyHit(KEY_UP)
				kd_left = KeyHit(KEY_LEFT)
				kd_right = KeyHit(KEY_RIGHT)
				kd_down = KeyHit(KEY_DOWN)
				FlushKeys()
			'_________________________
			
			'Status___________________
				
				If lState <> gState
					mapLoad(levelThis)
				EndIf
				
				levelLast = levelThis
				lState = gState
			'_________________________
			
			'Proceed__________________
				
				'Main_Menu
				If kh_esc Then
					gState = cMENU
					levelThis = 1
					menuSelect = 2
					menuSelected = -1
					charKeys = 0
					charRadValue = 0
				EndIf
				
				'Movement
				If kd_up Then
					charDir = cNORTH
					charMove = True
				ElseIf kd_left Then
					charDir = cWEST
					charMove = True
				ElseIf kd_right Then
					charDir = cEAST
					charMove = True
				ElseIf kd_down Then
					charDir = cSOUTH
					charMove = True
				Else
					charMove = False
				EndIf
				
				'Tile/Position_to_Tile/Index
				TX = (tileOffX/tileSize)
				TY = (tileOffY/tileSize)
				
				For Local l:Int = 0 To 1
					map[TX, TY, l, 2] = True
				Next
				

				If charMove Then
					
					If (tx-1 >= 0) And (tx+1 <= mapDim[0]) Then
						If (ty-1 >=0) And (ty+1 <= mapDim[1]) Then
							
							Select charDir
								Case cNORTH
									If (map[tx, ty-1,0,0] = 2) Or (map[tx, ty-1,0,0] = 3) Then
										tileOffY :- tileSize
									EndIf
								Case cEAST
									If (map[tx+1, ty,0,0] = 2) Or (map[tx+1, ty,0,0] = 3) Then
										tileOffx :+ tileSize
									EndIf
								Case cSOUTH
									If (map[tx, ty+1,0,0] = 2) Or (map[tx, ty+1,0,0] = 3) Then
										tileOffY :+ tileSize
									EndIf
								Case cWEST
									If (map[tx-1, ty,0,0] = 2) Or (map[tx-1, ty,0,0] = 3)Then
										tileOffX :- tilesize
									EndIf
							End Select		
												
						EndIf
					EndIf
					
					
					If (MilliSecs()>charFrameStart+charFrameTime) Then
						charAnim = (charAnim + 1) Mod charFrames
						charFrame = charDir*charFrames+charAnim
						charFrameStart = MilliSecs()
						PlaySound mapSFX[0], mapCHN
					EndIf
				Else
					charFrame = charDir-1
				EndIf
				
				'Pickups_and_Doors
				
				tileThis = map[tx,ty,1,0]
				
				Select tileThis
				
					Case tile_KEY
						charKeys :+ 1
						map[tx,ty,1,0]=0
						PlaySound mapSFX[1]
						
					Case tile_DIAMOND
						charRadValue :+ 100
						map[tx,ty,1,0]=0
						PlaySound mapSFX[2]
						
					Case tile_DOORCLOSE
						If (charKeys>0) Then
							map[tx,ty,1,0] :+ 1
							charKeys :- 1
							PlaySound mapSFX[3]
						EndIf
						
					Case tile_DOOROPEN
						levelThis :+ 1
						charKeys = 0
						charRadValue = 50
				End Select

				
				'View-Radius
				If (charRadValue > 100) Then charRadValue = 100
				If (charRadValue > 0)
					If (MilliSecs() > (charRadStart+charRadTime)) Then
						charRadValue :- 1
						charRadStart = MilliSecs()
					EndIf
				Else
					gState = cMENU
					levelThis = 1
					menuSelect = 2
					menuSelected = -1
					charKeys = 0
					charRadValue = 0
				EndIf
				
			'_________________________
			
			'Output___________________				
				
				SetBlend(ALPHABLEND)
					For Local l:Int = 0 To mapDim[2]-1
						For Local y:Int = 0 To mapDim[1]-1
							For Local x:Int = 0 To mapDim[0]-1
								SetRotation(map[x,y,l,1]*90)
								
								Local col:Int
								Local dist:Float = Abs(x-tx)+Abs(y-TY)
								If charRadValue = 0 Then
									col=0
								Else
									If (dist<1) Then
										col=255
									ElseIf (dist<2) Then
										col=32+charRadValue*(255-32)
									ElseIf (dist<3) Then
										col=charRadValue Or 8
									Else
										If (map[x,y,l,2] = True) Then
											col=8
										Else
											col=0
										EndIf
									EndIf
								EndIf
								
								SetColor(col,col,col)
								
								If (map[x,y,l,0] <> tile_START) Then
									DrawImage(tileImg, midX+(x*tileSize)-tileOffX, midY+(y*tileSize)-tileOffY, map[x,y,l,0])
								EndIf
							Next
						Next
					Next
				
				SetColor(255,255,255)	
				SetRotation(0)
				SetBlend(ALPHABLEND)
				
					DrawImage(charImg, midX, midY, charFrame)
					
					DrawImage(tileImg, (tileSize/2), (tileSize/2), tile_KEY)
					DrawImage(tileImg, gWidth-(100+tileSize/2), (tileSize/2), tile_DIAMOND)
					
				SetBlend(SOLIDBLEND)
					DrawImageRect(radvalImg, gWidth-(100+16), (tileSize/2-8), charRadValue, ImageHeight(radvalImg))
					
				SetScale(2,2)
					DrawText(" X " + charKeys, tileSize-16, 16)
				
				SetScale(1,1)
					
					DrawText("TX: "+TX+"|OffX: "+tileOffX, 5, 100)
					DrawText("TY: "+TY+"|OffY: "+tileOffY, 5, 120)
					
				SetColor(255,255,0)
					DrawRect(midX-1, midY-1, 3, 3)
			'_________________________
			
			'ChangeLevel______________
				If (levelThis <> levelLast) Then
					levelThis = mapLoad(levelThis)
					If levelThis = 0 Then
						gState = cMENU
						levelThis = 1
						menuSelect = 2
						menuSelected = -1
					EndIf
				EndIf
			'_________________________
	End Select
	
	Flip
	Cls
Wend
'________________________________________________


'Get_Tiles_______________________________________
Function getTiles:Int(path:String, size:Byte)
	Local img:TImage = LoadImage(path)
	Local width:Int = ImageWidth(img)
	Local height:Int = ImageHeight(img)
	Local tiles:Int = (width/size)*(height/size)
	img = Null
	Return tiles
End Function
'________________________________________________


'Load_Map________________________________________
Function mapLoad:Int(level:Int)
	
	Local strLevel:String
	
	If (level < 10) Then
		strLevel = "0" + String(level)
	Else
		strLevel = String(level)
	EndIf
	
	Local path:String = "data/maps/map" +strLevel+ ".map"
	Local file:TStream = OpenFile(path)
	
	If file Then
		
		mapDim = New Int[3]
		mapDim[0] = ReadByte(file)
		mapDim[1] = ReadByte(file)
		mapDim[2] = ReadByte(file)
		
		map = New Int[mapDim[0], mapDim[1], mapDim[2], 3]
		
		ReadLine(file)
		
		For Local r:Int = 0 To 1
			For Local l:Int = 0 To mapDim[2]-1
				For Local y:Int = 0 To mapDim[1]-1
					For Local x:Int = 0 To mapDim[0]-1
						map[x, y, l, r] = ReadInt(file)
						If r = 0 Then
							If map[x, y, l, r] = 1 Then
								tileOffX = x*tileSize
								tileOffY = y*tileSize
							EndIf
						EndIf
					Next
					ReadLine(file)
				Next
				ReadLine(file)
			Next
			ReadLine(file)
		Next
		
		CloseFile file
		FlushKeys()
		
		Return level
	Else
		Return 0
	EndIf
	
	
End Function
'________________________________________________

'Count_LEVEL_____________________________________
Function countLevel:Int(path:String)
	Local index:Int
	Local file:String
	
	Local dir:Int = ReadDir(path)
	
	If dir Then
		Repeat
			file = NextFile(dir)
			If (Instr(file, ".map")) Then
				index :+ 1
			EndIf
		Until (file="")
		
		Return index
	Else
		RuntimeError("Verzeichnis " +Chr(13)+ "data/maps/" +Chr(13)+ " nicht gefunden")
	EndIf
End Function

'________________________________________________